#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Optimization;
using HeuristicLab.Parameters;

namespace HeuristicLab.Problems.DataAnalysis {
  [StorableClass]
  [Item("RegressionProblem", "")]
  [Creatable]
  public class RegressionProblem : DataAnalysisProblem<IRegressionProblemData>,
    IRegressionProblem {
    private const string ProblemDataParameterName = "ProblemData";
    #region properties
    public new IDataAnalysisEvaluator<IRegressionProblemData> Evaluator {
      get { throw new NotImplementedException(); }
    }

    public new IRegressionSolutionCreator SolutionCreator {
      get { throw new NotImplementedException(); }
    }
    IDataAnalysisSolutionCreator<IRegressionProblemData> IDataAnalysisProblem<IRegressionProblemData>.SolutionCreator {
      get { throw new NotImplementedException(); }
    }
    #endregion

    public RegressionProblem(RegressionProblem original, Cloner cloner)
      : base(original, cloner) {
      RegisterEventHandlers();
    }
    [StorableConstructor]
    public RegressionProblem(bool deserializing) : base(deserializing) { }
    public RegressionProblem()
      : base() {
      Parameters.Add(new ValueParameter<IRegressionProblemData>(ProblemDataParameterName, "", new RegressionProblemData()));
      RegisterEventHandlers();
    }

    [StorableHook(HookType.AfterDeserialization)]
    private void AfterDeserialization() {
      RegisterEventHandlers();
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new RegressionProblem(this, cloner);
    }

    private void RegisterEventHandlers() {
      ProblemDataParameter.Value.Changed += new EventHandler(Value_Changed);
    }

    #region event propagation
    private void Value_Changed(object sender, EventArgs e) {
      OnReset();
    }
    #endregion
  }
}
